﻿using database;

namespace Forms
{
	public partial class FormMain : Form
	{

		public FormMain()
		{
			InitializeComponent();
		}

		private void carModelToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(FormCarModel));
			if (service is FormCarModel form)
			{
				form.ShowDialog();
			}
		}

		private void carToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(FormCar));
			if (service is FormCar form)
			{
				form.ShowDialog();
			}
		}

		private void branchToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(FormBranch));
			if (service is FormBranch form)
			{
				form.ShowDialog();
			}
		}

		private void clientToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(FormBranch));
			if (service is FormBranch form)
			{
				form.ShowDialog();
			}
		}

		private void rentalToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(FormRental));
			if (service is FormRental form)
			{
				form.ShowDialog();
			}
		}

		private void buttonTest_Click(object sender, EventArgs e)
		{
			var service = Program.ServiceProvider?.GetService(typeof(Abstractions));
			if (service is Abstractions bd)
			{
				var client = new Client()
				{
					Id = 0,
					Address = "awsedff",
					Email = "afdgaw",
					Name = "aedfrg",
					Phone = "asda",
					Surname = "dfgvsdfg",
				};

				DateTime startTime = DateTime.Now;
				bd.DeleteClient(10);
				bd.DeleteClient(11);
				bd.DeleteClient(12);
				bd.DeleteClient(13);
				bd.DeleteClient(14);
				DateTime endTime = DateTime.Now;

				// Выводим время выполнения запроса в консоль
				textBoxTest.Text = $"Время выполнения запроса: {(endTime - startTime).TotalMilliseconds} миллисекунд";
			}
		}

		private void trackBarDB_MouseUp(object sender, MouseEventArgs e)
		{
			if (trackBarDB.Value > 50)
			{
				trackBarDB.Value = 100;
				Program.ChangeDB(false);
			}
			else
			{
				trackBarDB.Value = 0;
				Program.ChangeDB(true);
			}
		}

		private void buttonTransferDataFromPostgresToMongo_Click(object sender, EventArgs e)
		{
			ImplementationMongoDB implementationMongoDB = new();

			// очищаем всё 
			foreach (var it in implementationMongoDB.GetBranches())
				implementationMongoDB.DeleteBranch(it.Id);
			foreach (var it in implementationMongoDB.GetClients())
				implementationMongoDB.DeleteClient(it.Id);
			foreach (var it in implementationMongoDB.GetCarModels())
				implementationMongoDB.DeleteCarModel(it.Id);
			foreach (var it in implementationMongoDB.GetCars())
				implementationMongoDB.DeleteCar(it.Id);
			foreach (var it in implementationMongoDB.GetRentals())
				implementationMongoDB.DeleteRental(it.Id);

			ImplementationPostgres implementationPostgres = new();

			// скачиваем из постгреса
			var listBranches = implementationPostgres.GetBranches();
			var listClients = implementationPostgres.GetClients();
			var listCarModels = implementationPostgres.GetCarModels();
			var listCars = implementationPostgres.GetCars();
			var listRentals = implementationPostgres.GetRentals();

			// вливаем данные монго дб
			foreach (var it in listBranches)
				implementationMongoDB.AddBranch(it);
			foreach (var it in listClients)
				implementationMongoDB.AddClient(it);
			foreach (var it in listCarModels)
				implementationMongoDB.AddCarModel(it);
			foreach (var it in listCars)
				implementationMongoDB.AddCar(it);
			foreach (var it in listRentals)
				implementationMongoDB.AddRental(it);
		}

		/*
        private Abstractions bd = new Implementation();
        private void button1_Click(object sender, EventArgs e)
        {
            List<Branch> branches = bd.GetBranches();

            // Очищаем dataGridView1 перед заполнением новыми данными
            dataGridView1.Rows.Clear();

            // Предварительно определяем столбцы, если это не было сделано ранее
            if (dataGridView1.ColumnCount == 0)
            {
                dataGridView1.Columns.Add("Id", "ID");
                dataGridView1.Columns.Add("Name", "Name");
                dataGridView1.Columns.Add("Address", "Address");
                dataGridView1.Columns.Add("Phone", "Phone");
                dataGridView1.Columns.Add("WorkingHours", "Working Hours");
            }

            // Заполняем dataGridView1 данными из списка branches
            foreach (Branch branch in branches)
            {
                dataGridView1.Rows.Add(branch.Id, branch.Name, branch.Address, branch.Phone, branch.WorkingHours);
            }
        }
        */
	}
}
