﻿using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Bson;

namespace database
{
    // Определение моделей данных

    public class Car
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public int ModelId { get; set; }
        public int BranchId { get; set; }
        public int Year { get; set; }
        public int Mileage { get; set; }
        public int StatusId { get; set; }
    }

    public class Client
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public string Name { get; set; }
        public string Surname { get; set; }
        public string Address { get; set; }
        public string Phone { get; set; }
        public string Email { get; set; }
    }

    public class Rental
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public int CarId { get; set; }
        public int ClientId { get; set; }
        public DateTime StartDate { get; set; }
        public DateTime EndDate { get; set; }
        public decimal Cost { get; set; }
    }

    public class CarModel
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public string Brand { get; set; }
        public string Model { get; set; }
        public int Year { get; set; }
        public int BodyTypeId { get; set; }
        public int Seats { get; set; }
    }

    public class Branch
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public string Name { get; set; }
        public string Address { get; set; }
        public string Phone { get; set; }
        public string WorkingHours { get; set; }
    }

    public class Status
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public string Title { get; set; }
    }

    public class BodyType
    {
		[BsonRepresentation(BsonType.Int32)]
		public int Id { get; set; }
        public string Title { get; set; }
    }

    public class helpCombobox
    {
        public string Text { get; set; }
        public int Id { get; set; }
    }
}
